# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import pygtk
pygtk.require('2.0')
import gtk
import sys
import os
import shutil
from scan_item import scan_item
from util import get_token_value
from util import replace

class tab_dump_time(gtk.VBox):

	lines=[]
	edit_list=[]
	file_name=""
	line_number=[]
	name=""
	visible=1
	def callback_edit(self, widget):
		mylist=[]
		text=self.textbuffer.get_text(self.textbuffer.get_start_iter(),self.textbuffer.get_end_iter(),False)
		mylist=text.split()

		#line=self.line_number[data]
		#self.lines[line]=self.edit_list[data].get_text()
		#self.edit_list[data].set_text(self.lines[line])
		print "Sim dir",self.sim_dir+'dump_time.inp'
		a = open(self.sim_dir+'dump_time.inp', "w")
		a.write(str(len(mylist))+"\n")
		for i in range(0,len(mylist)):
			a.write(mylist[i]+"\n")
		a.close()

	def callback_toggled(self, widget):
		ans=0
		if self.check_button.get_active()==True:
			ans=1
		else:
			ans=0

		replace("dump.inp", "#dump_slices", str(ans))


	def wow(self,sim_dir):
		self.main_box=gtk.VBox()
		self.sim_dir=sim_dir
		self.edit_list=[]
		self.line_number=[]

		f = open(self.sim_dir+"dump_time.inp")
		self.lines = f.readlines()
		f.close()

		clean=[]
		del self.lines[0]

		for i in range (0,len(self.lines)):
			if self.lines[i]!="\n":
				clean.append(self.lines[i])


		mytext=''.join(clean)


		self.text = gtk.TextView()
		self.text.set_editable(True)
		self.textbuffer = self.text.get_buffer()

	        self.textbuffer.set_text(mytext)
		#self.text.set_text(mytext)

		#self.text.connect("insert-at-cursor", self.callback_edit)
		self.textbuffer.connect("changed", self.callback_edit)

		self.text.show()
		self.main_box.add(self.text)

		self.check_button=gtk.CheckButton("Dump the band structure as a the simulation proceeds")
		self.check_button.connect("toggled", self.callback_toggled)
		self.check_button.set_active(int(get_token_value("dump.inp", "#dump_slices")))
		self.check_button.show()
		self.main_box.add(self.check_button)

		self.add(self.main_box)
		self.main_box.show()
#
		#n=0
		#pos=0
		#for i in range(0, len(self.lines)/2):

		#	show=False
		#	units="Units"
		#	out_text=self.lines[pos]
		#	if out_text == "#mueffe":
		#		units="m<sup>2</sup>V<sup>-1</sup>s<sup>-1</sup>"
		#		text_info="Electron mobility"
		#		show=True


