# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import pygtk
pygtk.require('2.0')
import gtk
import sys
import os
import shutil
import copy
import pdb
import logging
from plot_command import plot_command_class

class used_files_menu:

	def init(self,config_file,callback):
		logging.info("used_file_menu init")
		try:
			for i in self.menu.get_children():
				self.menu.remove(i)
		except:
			self.menu=gtk.Menu()

		self.last_items=[]
		self.config_file=config_file
		self.callback=callback
		self.base_dir=os.path.dirname(config_file)+'/'

	def append(self,plot_token):
		logging.info("used_file_menu append")
		file_name=plot_token.file0+plot_token.tag0+plot_token.file1+plot_token.tag1

		if self.last_items.count(file_name)==0:
			menu_item = gtk.MenuItem(file_name)
			self.menu.append(menu_item)
			self.last_items.append(plot_token)
			ref=self.last_items[len(self.last_items)-1]
			menu_item.connect("activate", self.callback,ref)
			self.save_list()
			menu_item.show()

	def save_list(self):
		logging.info("used_file_menu save_list")
		a = open(self.config_file, "w")
		a.write(str(len(self.last_items))+"\n")
		for i in range(0,len(self.last_items)):
			a.write(self.last_items[i].path+"\n")
			a.write(self.last_items[i].file0+"\n")
			a.write(self.last_items[i].tag0+"\n")
			a.write(self.last_items[i].file1+"\n")
			a.write(self.last_items[i].tag1+"\n")

		a.close()

	def reload_list(self):
		logging.info("used_file_menu reload_list")
		print "Loading menu",self.config_file

		for i in self.menu.get_children():
			self.menu.remove(i)
		try:
			f=open(self.config_file)
			config = f.readlines()
			f.close()

			for ii in range(0, len(config)):
				config[ii]=config[ii].rstrip()

			number=int(config[0])

			for ii in range(0, number):
				pos=1+ii*5

				readitem=plot_command_class()
				readitem.path=config[pos+0]
				readitem.file0=config[pos+1]
				readitem.tag0=config[pos+2]
				readitem.file1=config[pos+3]
				readitem.tag1=config[pos+4]

				self.append(readitem)

		except IOError:
			print "No file found"



